<?php

include('../includes/global.php');
include('../includes/dbc.php');

function ImportSQLMangos()
{
  global $Database, $TranslationTree;

  echo('Načítání textů z databáze MaNGOSu...');
  foreach($TranslationTree as $Group)
  {
    if(($Group['MangosTable'] != '') and ($Group['TablePrefix'] != ''))
    {
	  echo('<br />'.$Group['Name'].'<br />');
	  $Columns = '`'.$Group['MangosDatabase'].'`.`'.$Group['MangosTable'].'`.`'.$Group['MangosTableIndex'].'`';
	  foreach($Group['Items'] as $GroupItem)
        $Columns .= ', `'.$Group['MangosDatabase'].'`.`'.$Group['MangosTable'].'`.`'.$GroupItem['MangosColumn'].'` AS `'.$GroupItem['Column'].'`';
	  $Query = 'SELECT '.$Columns.' FROM `'.$Group['MangosDatabase'].'`.`'.$Group['MangosTable'].'`'; 
	  //echo($Query.'<br />');	
	  $Count = 0;
	  $NewCount = 0;
	  $DbResult = $Database->SQLCommand($Query);
	  while($DbRow = mysql_fetch_assoc($DbResult))
	  {
		//echo('SELECT ID FROM '.$Group['TablePrefix'].' WHERE entry='.$DbRow[$Group['MangosTableIndex']].' AND Language=0'."<br>");
	    $DbResult2 = $Database->SQLCommand('SELECT ID FROM '.$Group['TablePrefix'].' WHERE entry='.$DbRow[$Group['MangosTableIndex']].' AND Language=0');
	    if(isset($DbResult2) and (mysql_num_rows($DbResult2) > 0))
	    {
	      $DbRow2 = mysql_fetch_assoc($DbResult2);
		  //echo($DbRow2['ID']);
		  $ColumnsValues = '';
	      foreach($Group['Items'] as $GroupItem)
		  {
  	        $ColumnsValues .= ', `'.$GroupItem['Column'].'`="'.addslashes($DbRow[$GroupItem['MangosColumn']]).'"';
		  }
		  $ColumnsValues = substr($ColumnsValues, 2);
		  echo('. '); //'UPDATE `'.$Group['TablePrefix'].'` SET '.$ColumnsValues.' WHERE ID='.$DbRow2['ID']."<br>");
		  //print_r($DbRow2);
		  $Database->SQLCommand('UPDATE `'.$Group['TablePrefix'].'` SET '.$ColumnsValues.' WHERE ID='.$DbRow2['ID']);
	    } else 
	    {
		  $Columns = 'entry, language';
		  $Values = $DbRow[$Group['MangosTableIndex']].', 0';
	      foreach($Group['Items'] as $GroupItem)
		  {
  	        $Columns .= ', `'.$GroupItem['Column'].'`';
		    $Values .= ', "'.addslashes($DbRow[$GroupItem['MangosColumn']]).'"';
		  }
		  //$Columns = substr($Columns, 2);
		  //$Values = substr($Values, 2);
		  $Database->SQLCommand('INSERT `'.$Group['TablePrefix'].'` ('.$Columns.') VALUES ('.$Values.')');
		  echo('# ');
		  //echo('INSERT `'.$Group['TablePrefix'].'` ('.$Columns.') VALUES ('.$Values.')'."<br>");
  	      $NewCount++;
	    }
	    $Count++;
	  }
	  echo('<br />Celkem: '.$Count.'  Nových: '.$NewCount.'<br />');
	}
  }
  echo('Dokončeno.</div>');
}

function ImportDBC()
{
  global $Database, $TranslationTree, $Config;

  echo('Načítání textů z DBC souborů...');
  foreach($TranslationTree as $Group)
  {
    if(($Group['DBCFileName'] != '') and ($Group['TablePrefix'] != ''))
    {
      echo('<br />'.$Group['Name'].'<br />');	
	  $DBCFile = new DBCFile();
	  $DBCFile->OpenFile('../source/'.$Config['Web']['GameVersion'].'/dbc/'.$Group['DBCFileName'].'.dbc', $Group['DBCColumns']);
	  $ItemCount = $DBCFile->GetRecordCount();
	  $NewCount = 0;
	  $Count = 0;
	  for($i = 0; $i < $ItemCount; $i++)
      {
        $ItemId = $DBCFile->GetUint($i, 0);  
        $DbResult2 = $Database->SQLCommand('SELECT ID FROM '.$Group['TablePrefix'].' WHERE entry='.$ItemId.' AND Language=0');
        if(isset($DbResult2) and (mysql_num_rows($DbResult2) > 0))
	    {
  		  $DbRow2 = mysql_fetch_assoc($DbResult2);
		  //echo($DbRow2['ID']);
		  $ColumnsValues = '';
	      foreach($Group['Items'] as $GroupItem)
		  {
  	        $ColumnsValues .= ', `'.$GroupItem['Column'].'`="'.addslashes($DBCFile->GetString($i, $GroupItem['DBCColumnIndex'])).'"';
		  }
		  $ColumnsValues = substr($ColumnsValues, 2);
		  echo('. '); //'UPDATE `'.$Group['TablePrefix'].'` SET '.$ColumnsValues.' WHERE ID='.$DbRow2['ID']."<br>");
		  //print_r($DbRow2);
		  $Database->SQLCommand('UPDATE `'.$Group['TablePrefix'].'` SET '.$ColumnsValues.' WHERE ID='.$DbRow2['ID']);
	    } else 
	    {
  		  $Columns = 'entry, language';
		  $Values = $ItemId.', 0';
	      foreach($Group['Items'] as $GroupItem)
		  { 
	        $Columns .= ', `'.$GroupItem['Column'].'`';
		    $Values .= ', "'.addslashes($DBCFile->GetString($i, $GroupItem['DBCColumnIndex'])).'"';
		  }
		  //$Columns = substr($Columns, 2);
		  //$Values = substr($Values, 2);
		  $Database->SQLCommand('INSERT `'.$Group['TablePrefix'].'` ('.$Columns.') VALUES ('.$Values.')');
		  echo('# ');
		  //echo('INSERT `'.$Group['TablePrefix'].'` ('.$Columns.') VALUES ('.$Values.')'."<br>");
  	      $NewCount++;
	    }
  	    $Count++;
	  }
	  echo('<br />Celkem: '.$Count.'  Nových: '.$NewCount.'<br />');
    }  	
  }
  echo('Dokončeno.</div>');
}

function ImportLUA()
{
  global $Database, $TranslationTree, $PatchVersion, $Config;

  echo('Načítání textů z LUA souborů...');
  foreach($TranslationTree as $Group)
  {
    if(($Group['LuaFileName'] != '') and ($Group['TablePrefix'] != ''))
    {
      echo('<br />'.$Group['Name'].'<br />');	
	  $File = new FileStream();
	  $File->OpenFile('../source/'.$Config['Web']['GameVersion'].'/lua/'.$Group['LuaFileName'].'.lua');
	  $NewCount = 0;
	  $Count = 0;
	  while(!$File->EOF())
	  {
		$Line = $File->ReadLine();
		if(strpos($Line, '=') !== false)
	    {
		  $LineParts = explode(';', $Line);
          $LineParts2 = explode('=', $LineParts[0]);
		  $Value['ShortCut'] = trim($LineParts2[0]);
		  $Value['Text'] = substr(trim($LineParts2[1]), 1, -1);
		  $Value['Comment'] = addslashes(substr(trim($LineParts[1]), 3));

          $DbResult2 = $Database->SQLCommand('SELECT ID FROM '.$Group['TablePrefix'].' WHERE ShortCut="'.$Value['ShortCut'].'" AND (Language=0)');
          if(isset($DbResult2) and (mysql_num_rows($DbResult2) > 0))
	      {
		    $ColumnsValues = '';
	        foreach($Group['Items'] as $GroupItem)
		    {
              $ColumnsValues .= ', `'.$GroupItem['Column'].'`="'.$Value[$GroupItem['Column']].'"';
	  	    }
            $ColumnsValues = substr($ColumnsValues, 2);

  		    $DbRow2 = mysql_fetch_assoc($DbResult2);
		    echo('. '); //'UPDATE `'.$Group['TablePrefix'].'` SET '.$ColumnsValues.' WHERE ID='.$DbRow2['ID']."<br>");
		    $Database->SQLCommand('UPDATE `'.$Group['TablePrefix'].'` SET '.$ColumnsValues.' WHERE ID='.$DbRow2['ID']);
	      } else 
	      {
			$Entry = 1;
			$DbResult = $Database->SQLCommand('SELECT MAX(`entry`) FROM `'.$Group['TablePrefix'].'`');
			if(mysql_num_rows($DbResult) > 0)
			{
			  $DbRow = mysql_fetch_row($DbResult);
			  $Entry += $DbRow[0];
            }
						
  		    $Columns = 'entry, language, ShortCut';
		    $Values = $Entry.', 0, "'.$Value['ShortCut'].'"';
	        foreach($Group['Items'] as $GroupItem)
		    { 
	          $Columns .= ', `'.$GroupItem['Column'].'`';
		      $Values .= ', "'.$Value[$GroupItem['Column']].'"';
		    }
		    $Database->SQLCommand('INSERT `'.$Group['TablePrefix'].'` ('.$Columns.') VALUES ('.$Values.')');
		    echo('# ');
  	        $NewCount++;
	      }
		};	
        $Count++;
	  }
	  echo('<br />Celkem: '.$Count.'  Nových: '.$NewCount.'<br />');
    }  	
  }
  echo('Dokončeno.</div>');
}

ShowPage();

if(!Licence(LICENCE_ADMIN))
{
  echo('Nemáte oprávnění');
  ShowFooter();
}

if(!array_key_exists('source', $_GET))
{
  echo('<div><strong>Načíst zdroj:</strong></div>');
  echo('<div><a href="?source=dbc">DBC soubory</a></div>');
  echo('<div><a href="?source=sql_mangos">SQL MaNGOS</a></div>');
  echo('<div><a href="?source=lua">LUA soubory</a></div>');
} else
{
  echo('<div style="font-size: xx-small;">');
  switch($_GET['source'])
  {
    case 'sql_mangos':
	  ImportSQLMangos();
      break;
    case 'dbc':
	  ImportDBC();
	  break;
    case 'lua':
	  ImportLUA();
	  break;
  }
  WriteLog('Plnění databáze', 4);
}
  
ShowFooter();      

?>
